// -*- c++ -*-
/*  Generated by gensig from canvas-item.gen_h. DO NOT MODIFY!!! */
#ifndef GNOMEMM_CANVAS_ITEM_HEADER
#define GNOMEMM_CANVAS_ITEM_HEADER
/* $Id: canvas-item.gen_h,v 1.23 1999/02/01 21:30:32 mirko Exp $ */
// -*- C++ -*- // this is for the .gen_h, I realize gensig puts one in

/* canvas-item.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk--/object.h>
#include <libgnomeui/gnome-canvas.h>

class Gnome_Canvas;
class Gnome_CanvasGroup;

class Gnome_CanvasItem_Class;
#line 30 "canvas-item.gen_h"

class Gnome_CanvasItem : public Gtk_Object {
  // constness if f*ed up, so just mutable these.
  mutable Gtk_ObjectHandle<Gnome_CanvasGroup> parent_;
  mutable Gtk_ObjectHandle<Gnome_Canvas>      canvas_;
public:
protected:
  typedef Gnome_CanvasItem_Class    CppClassType;
  typedef GnomeCanvasItem           BaseObjectType;
  typedef GnomeCanvasItemClass      BaseClassType;

  virtual void *get_parent_class();

private:
  friend CppClassType;
  static CppClassType canvas_item_class; 
  GtkType get_type(); 

public:

#line 37 "canvas-item.gen_h"


  static void cpp_class_init(GtkObject*);
  Gnome_CanvasItem(GnomeCanvasItem *castitem);

  void item_construct(const Gnome_CanvasGroup &parent,
                      const _gtk_string &first_arg_name = 0,
                      va_list ap = 0);

  virtual ~Gnome_CanvasItem();
  

  //: Set arguments - this is the main way you manipulate
  //:  a CanvasItem
  void set(const _gtk_string &first_arg_name, ...);

  //:  Move an item by the specified amount
  void move (double dx, double dy);

  //: Raise an item in the z-order of its parent group by the specified
  //: number of positions.  If the number is zero, then the item will
  //: be made the topmost of its parent group.
  void raise (guint positions);

  //: Lower an item in the z-order of its parent group by the specified
  //: number of positions.  If the number is zero, then the item will be
  //: made the bottommost of its parent group.  */
  void lower (guint positions);

  //: Raise an item to the top of its parent group's z-order.
  void raise_to_top ();

  //: Lower an item to the bottom of its parent group's z-order
  void lower_to_bottom ();

  //: Grab the mouse for the specified item.  Only the events in
  //: event_mask will be reported.  If cursor is non-NULL, it will be
  //: used during the duration of the grab.  Time is a proper X event
  //: time parameter.  Returns the same values as XGrabPointer().
  int grab (unsigned int event_mask, GdkCursor *cursor, guint32 etime);

  //: Ungrabs the mouse -- the specified item must be the same that was
  //: passed to gnome_canvas_item_grab().  Time is a proper X event
  //: time parameter. 
  void ungrab (guint32 etime);

  //: These functions convert from a coordinate system to another.  "w"
  //: is world coordinates and "i" is item coordinates. 
  void w2i (double *x, double *y);
  void i2w (double *x, double *y);

  //: Used to send all of the keystroke events to a specific item as well 
  //: as GDK_FOCUS_CHANGE events.
  void grab_focus ();

  //: Fetch the bounding box of the item.  The bounding box may not be 
  //: exactly tight, but the canvas items will do the best they can.
  void get_bounds (double *x1, double *y1, double *x2, double *y2);

  //: Make the item visible
  void show();
  
  //: Hide the item
  void hide();

  //: Returns the canvas we're on.
  Gnome_Canvas* canvas() const;

  //: Returns the parent canvas item - could be 0 for root item
  Gnome_CanvasGroup* parent() const;
  
  //: Tell the item to update itself.  The flags are from the update flags
  //: defined above.  The item should update its internal state from its
  //: queued state, recompute and request its repaint area, etc.  The
  //: affine, if used, is a pointer to a 6-element array of doubles.


  //: Realize an item -- create GCs, etc. 

  
  //: Unrealize an item 

  
  //: Map an item - normally only need by items with their own GdkWindows 

  
  //: Unmap an item 


  //: Return the microtile coverage of the item

  
  //: Draw an item of this type.  (x, y) are the upper-left canvas
  //: pixel coordinates of the drawable, a temporary pixmap,
  //: where things get drawn.  (width, height) are the dimensions
  //: of the drawable.  



  //: Calculate the distance from an item to the specified point.  It
  //: also returns a canvas item which is the item itself in the case
  //: of the object being an actual leaf item, or a child in case of
  //: the object being a canvas group.  (cx, cy) are the canvas pixel
  //: coordinates that correspond to the item-relative coordinates (x,
  //: y). 
  // FIXME GnomeCanvasItem should be a C++ object, see Gtk_Container for example

  
  //: Move an item by the specified amount 


  //: Fetch the bounding box of the item

  
  //: Signal: an event ocurred for an item of this type.  The (x, y)
  //: coordinates are in the canvas world coordinate system.  
  Signal_proxy1_r<gint,BaseObjectType,GdkEvent*> event;
  
protected:
  /* impl functions */
  virtual void update_impl(double* p1, ArtSVP* p2, int p3);
  virtual void realize_impl();
  virtual void unrealize_impl();
  virtual void map_impl();
  virtual void unmap_impl();
  virtual ArtUta* coverage_impl();
  virtual void draw_impl(GdkDrawable* p1, int p2, int p3, int p4, int p5);
  virtual double point_impl(double p1, double p2, int p3, int p4, GnomeCanvasItem** p5);
  virtual void translate_impl(double p1, double p2);
  virtual void bounds_impl(double* p1, double* p2, double* p3, double* p4);
  virtual gint event_impl(GdkEvent* p1);
public:
  GnomeCanvasItem* gtkobj() { return GNOME_CANVAS_ITEM(gtkobject); }
  const GnomeCanvasItem* gtkobj() const { return GNOME_CANVAS_ITEM(gtkobject); }
  static bool isGnomeCanvasItem(Gtk_Object *checkcast);
#line 155 "canvas-item.gen_h"


private:
  Gnome_CanvasItem(); 
};

#endif
