// -*- c++ -*-
/*  Generated by gensig from canvas.gen_h. DO NOT MODIFY!!! */
#ifndef GNOMEMM_CANVAS_HEADER
#define GNOMEMM_CANVAS_HEADER
/* $Id: canvas.gen_h,v 1.21 1999/02/01 22:28:25 glaurent Exp $ */
// -*- C++ -*-

/* canvas.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomeui/gnome-canvas.h>
#include <gtk--/layout.h>

class Gnome_CanvasItem;
class Gnome_CanvasGroup;

class Gnome_Canvas_Class;
#line 30 "canvas.gen_h"

class Gnome_Canvas : public Gtk_Layout {
  Gtk_ObjectHandle<Gnome_CanvasGroup> root_;
public:
protected:
  typedef Gnome_Canvas_Class    CppClassType;
  typedef GnomeCanvas           BaseObjectType;
  typedef GnomeCanvasClass      BaseClassType;

  virtual void *get_parent_class();

private:
  friend CppClassType;
  static CppClassType canvas_class; 
  GtkType get_type(); 

public:

#line 35 "canvas.gen_h"


  static void cpp_class_init(GtkObject*);

  //: If you want to put Imlib image objects on the Canvas,
  //: you need to push the Imlib colormap/visual before creating
  //: the canvas, and pop it afterward.
  Gnome_Canvas();
  Gnome_Canvas(GnomeCanvas *castitem);
  virtual ~Gnome_Canvas();
  

  //: get the root canvas item
  Gnome_CanvasGroup& root();

  //: Limits of scroll region
  void set_scroll_region(double x1, double y1,
			 double x2, double y2);

  //: Get limits of scroll region
  void get_scroll_region(double* x1, double* y1,
			 double* x2, double* y2) const;
    
  //: Set the pixels/world coordinates ratio
  void set_pixels_per_unit(double n);

  //: Put this coordinate in the top-left corner of the window
  void scroll_to(int x, int y);

  //: Scroll offsets in canvas pixel coordinates.
  //: 0 for either pointer means not to return that value.
  void get_scroll_offsets (int *cx, int *cy) const;

  //: Repaint immediately, don't wait for idle loop
  //: (normally the canvas queues repainting and does it in an 
  //: idle loop)
  void update_now();

  //: Used only by item implementations. Request an eventual redraw
  //: of the region, which includes x1,y1 but not x2,y2
  void request_redraw(int x1, int y1,
		      int x2, int y2);
  
  //: Convert from World coordinates (units for the entire canvas)
  //: to Canvas coordinates (pixels starting at 0,0 in the top left
  //: of the visible area). The relationship depends on the current
  //: scroll position and the pixels_per_unit ratio (zoom factor)
  void w2c(double wx, double wy,
	   int *cx, int *cy) const;
  
  //: From Canvas to World
  void c2w(int cx, int cy,
	   double *wx, double *wy) const;

  //: Convert from Window coordinates (those used by the widget's GdkWindow)
  //:  to world coordinates. This is fairly low-level and not generally
  //:  useful.
  void window_to_world(double winx, double winy,
		       double* worldx, double* worldy) const;

  void world_to_window(double worldx, double worldy,
		       double* winx, double* winy) const;

  //: Parse color spec string and allocate it into the GdkColor.
  //:  Return TRUE unless the string is NULL
  bool get_color(const string &spec, GdkColor * color);

  // The following are simply accessed via the struct in C,
  //  but Federico reports that they are meant to be used.
  //: Get the pixels per unit.
  double get_pixels_per_unit() const { return gtkobj()->pixels_per_unit; }

  // No signals

protected:
  /* impl functions */
public:
  GnomeCanvas* gtkobj() { return GNOME_CANVAS(gtkobject); }
  const GnomeCanvas* gtkobj() const { return GNOME_CANVAS(gtkobject); }
  static bool isGnomeCanvas(Gtk_Object *checkcast);
#line 109 "canvas.gen_h"

protected:
};

#endif
